/**
 * This file was copied and re-packaged automatically by
 *     org.eclipse.qvtd.doc.miniocl.build.MiniOCLBuildEverything
 * from 
 *     ..\..\plugins\org.eclipse.qvtd.runtime\src\org\eclipse\qvtd\runtime\evaluation\InvocationFailedException.java
 *
 * Do not edit this file. 
 */
/*******************************************************************************
 * Copyright (c) 2013, 2019 Willink Transformations and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *   E.D.Willink - Initial API and implementation
 *******************************************************************************/
package org.eclipse.qvtd.doc.minioclcs.xtext.tx;

import org.eclipse.jdt.annotation.NonNull;
import org.eclipse.ocl.pivot.values.InvalidValueException;

/**
 * An InvocationFailedException is thrown when a Mapping invocation fails as a result of an attempt to
 * access a Property before its value has been assigned. The InvocationManager should catch the exception
 * and mark the invocation for a retry once the Property has been assigned.
 */
@SuppressWarnings("serial")
public class InvocationFailedException extends InvalidValueException
{
	public final @NonNull SlotState slotState;

	public InvocationFailedException(@NonNull SlotState slotState) {
		super("not-ready");
		this.slotState = slotState;
	}

	@Override
	public String toString() {
		return slotState.toString();
	}
}